## libevent 2.0.10-stable

=== debian/changelog ===
libevent (2.0.10-stable-1ubuntu0.10.04.2) lucid; urgency=low

  * Remove the -dev package

 -- Andreas Noteng <andreas@noteng.no>  Thu, 10 Feb 2011 22:54:53 +0100

libevent (2.0.10-stable-1ubuntu0.10.04.1) lucid; urgency=low

  * Backport to lucid

 -- Andreas Noteng <andreas@noteng.no>  Wed, 09 Feb 2011 22:27:04 +0100

libevent (2.0.10-stable-1ubuntu0~ppa1) natty; urgency=low

  * Copy from debian

 -- Andreas Noteng <andreas@noteng.no>  Mon, 31 Jan 2011 08:26:51 +0100

libevent (2.0.10-stable-1) experimental; urgency=low

  * New upstream release
    Closes: 581221, 607984
  * Install libevent*.pc into /usr/lib/pkgconfig
    Closes: 569274
  * The man pages event.3 and evdns.3 are not shipped anymore.
  * Fix out-of-date-standards-version
  * Source format is 3.0 (quilt)
  * Pass parameters -Zbzip2 and -z9 to dpkg-deb via dh_builddeb

 -- Anibal Monsalve Salazar <anibal@debian.org>  Sun, 16 Jan 2011 18:19:25 +1100

libevent (2.0.3-alpha-1) experimental; urgency=low

  * New upstream release

 -- Anibal Monsalve Salazar <anibal@debian.org>  Sat, 21 Nov 2009 23:35:53 +1100

=== debian/control ===
Source: libevent
Section: libs
Priority: optional
Maintainer: Anibal Monsalve Salazar <anibal@debian.org>
Build-Depends: debhelper (>= 7), autotools-dev, libtool, libssl-dev
Standards-Version: 3.9.1
Homepage: http://www.monkey.org/~provos/libevent/

Package: libevent-2.0-5
Section: libs
Priority: standard
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: An asynchronous event notification library
 The libevent API provides a mechanism to execute a callback function
 when a specific event occurs on a file descriptor or after a timeout
 has been reached.
 .
 libevent is meant to replace the asynchronous event loop found in
 event driven network servers. Currently, libevent supports /dev/poll,
 kqueue(2), event ports, select(2), poll(2) and epoll(4).
 .
 For backward compatibility and to transition to libevent_core only or
 libevent_core and libevent_extra, the libevent source package builds
 the libevent library that includes everything in libevent_core and
 libevent_extra.

Package: libevent-core-2.0-5
Section: libs
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: An asynchronous event notification library (core)
 The libevent API provides a mechanism to execute a callback function
 when a specific event occurs on a file descriptor or after a timeout
 has been reached.
 .
 libevent is meant to replace the asynchronous event loop found in
 event driven network servers. Currently, libevent supports /dev/poll,
 kqueue(2), event ports, select(2), poll(2) and epoll(4).
 .
 The libevent_core library includes event loops, timers, buffer code,
 and various small compatibility functions.
 .
 If you're writing software that only uses libevent's event loop, you
 should link against only the libevent_core library.

Package: libevent-extra-2.0-5
Section: libs
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libevent-core-2.0-5 (= ${binary:Version})
Description: An asynchronous event notification library (extra)
 The libevent API provides a mechanism to execute a callback function
 when a specific event occurs on a file descriptor or after a timeout
 has been reached.
 .
 libevent is meant to replace the asynchronous event loop found in
 event driven network servers. Currently, libevent supports /dev/poll,
 kqueue(2), event ports, select(2), poll(2) and epoll(4).
 .
 The libevent_extra library includes code for HTTP, DNS, RPC, and so
 on.
 .
 If you're writing software that uses libevent's protocol support, you
 need to link libevent_core and libevent_extra as well.

Package: libevent-pthreads-2.0-5
Section: libs
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libevent-core-2.0-5 (= ${binary:Version})
Description: An asynchronous event notification library (pthreads)
 The libevent API provides a mechanism to execute a callback function
 when a specific event occurs on a file descriptor or after a timeout
 has been reached.
 .
 libevent is meant to replace the asynchronous event loop found in
 event driven network servers. Currently, libevent supports /dev/poll,
 kqueue(2), event ports, select(2), poll(2) and epoll(4).
 .
 If you want threading support and you're using pthreads, you'll need
 to link against the libevent_pthreads library in addition to
 libevent_core.

Package: libevent-openssl-2.0-5
Section: libs
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libevent-core-2.0-5 (= ${binary:Version})
Description: An asynchronous event notification library (openssl)
 The libevent API provides a mechanism to execute a callback function
 when a specific event occurs on a file descriptor or after a timeout
 has been reached.
 .
 libevent is meant to replace the asynchronous event loop found in
 event driven network servers. Currently, libevent supports /dev/poll,
 kqueue(2), event ports, select(2), poll(2) and epoll(4).
 .
 There is now a bufferevent type that supports SSL/TLS using the
 OpenSSL library.  The code for this is build in a separate
 library, libevent_openssl, so that your programs don't need to
 link against OpenSSL unless they actually want SSL support.

## libevent 2.0.10-stable-1

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,22 @@
 Build-Depends: debhelper (>= 7), autotools-dev, libtool, libssl-dev
 Standards-Version: 3.9.1
 Homepage: http://www.monkey.org/~provos/libevent/
+
+Package: libevent-dev
+Section: libdevel
+Architecture: any
+Depends: ${misc:Depends}, libevent-2.0-5 (= ${binary:Version}),
+ libevent-core-2.0-5 (= ${binary:Version}),
+ libevent-extra-2.0-5 (= ${binary:Version}),
+ libevent-pthreads-2.0-5 (= ${binary:Version}),
+ libevent-openssl-2.0-5 (= ${binary:Version})
+Description: Development libraries, header files and docs for libevent
+ Contains the header files, documentation, examples and static libraries 
+ for use in developing applications that use the libevent library.
+ .
+ The libevent library is an asynchronous event notification library
+ that provides a mechanish to execute a callback function when a specific
+ event occurs on a file descriptor or after a timeout has been reached.
 
 Package: libevent-2.0-5
 Section: libs

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

config.status: configure
	dh_testdir
	cp -f /usr/share/misc/config.sub /usr/share/misc/config.guess .
	# Add here commands to configure the package.
	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info


build: build-stamp
build-stamp:  config.status
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f config.sub config.guess

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/tmp
	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr

	# Copy the example C files
	mkdir -p $(CURDIR)/debian/tmp/examples/
	cp $(CURDIR)/sample/*.c $(CURDIR)/debian/tmp/examples/
	cp $(CURDIR)/debian/Makefile.sample $(CURDIR)/debian/tmp/examples/Makefile

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_movefiles
	dh_installdocs
	dh_installexamples
	dh_installman
	dh_installchangelogs
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs -V
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb -- -Zbzip2 -z9

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
#opts=uversionmangle=s/\.(tar.*|tgz|zip|gz|bz2)$//i,dversionmangle=s/[-.+~]?(cvs|svn|git|snapshot|pre|hg)(.*)$//i,pasv \
#http://www.monkey.org/~provos/libevent/ (?:.*/)?libevent-?_?([\d+\.]+|\d+)\.(tar.*|tgz|zip|gz|bz2|) debian uupdate
opts=uversionmangle=s/\.(tar.*|tgz|zip|gz|bz2)$//i,dversionmangle=s/[-.+~]?(cvs|svn|git|snapshot|pre|hg)(.*)$//i,pasv \
http://www.monkey.org/~provos/libevent/ (?:.*/)?libevent-?_?(.+)\.(tar.*|tgz|zip|gz|bz2|) debian uupdate

## libevent 2.0.12-stable

=== debian/changelog ===
libevent (2.0.12-stable-1) experimental; urgency=low

  * [9be9bdb9] new upstream version 2.0.12-stable
  * [7a119447] add myself to uploaders (with permission from Anibal)
  * [5941f8df] add VCS- fields to debian/control
  * [3a410d4c] use dh 8 short style; remove unneeded build-dep on libtool
  * [5217845e] bump compat to 8
  * [3237604b] remove old README.source
  * [0cc15d5b] remove README.Debian; install whatsnew-2.0.txt to docs instead
  * [281c8d2e] source/options: don't set compression level (9 is the default 
               anyway)
  * [08517840] clean up debian/watch
  * [18d75ca4] remove unneeded debian/*.dirs
  * [1967343a] add TODO about cleaning up debian/copyright
  * [c567b3fd] install pkgconfig file with more generic glob (*.pc, instead of 
               libevent*.pc)
  * [3b6f7cb9] add ".pc" to .gitignore for quilt
  * [73325895] bump policy to 3.9.2 (no changes)
  * [2fe9450d] adding libevent-dbg package
  * [7d85b523] rename all *.files to *.install
  * [169fffc7] disable regression tests while building
  * [611912d3] add shlibs files for all lib packages
  * [6dec46d3] some copy-editing in debian/control
  * [4733768d] add patch to always build with -no-undefined
  * [f2916660] build with -Wl,--as-needed,-z,defs,--no-add-needed
  * [b8fc89d7] debian/control: remove redundant sections and priorities
  * [ebd9fa80] changelog entry for 2.0.12-stable-1

 -- Leo Costela <costela@debian.org>  Fri, 17 Jun 2011 16:01:41 +0200

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
LDFLAGS = -Wl,--as-needed,-z,defs,--no-add-needed

%:
	dh $@ --with autotools-dev

override_dh_auto_configure:
	dh_auto_configure -- --disable-libevent-regress

override_dh_strip:
	dh_strip --dbg-package=libevent-dbg

## libevent 2.0.16-stable

=== debian/changelog ===
libevent (2.0.16-stable-1) unstable; urgency=low

  * New upstream version 2.0.16-stable
  * Uploading to unstable, see http://bugs.debian.org/631018

 -- Anibal Monsalve Salazar <anibal@debian.org>  Mon, 28 Nov 2011 15:39:09 +1100

libevent (2.0.13-stable-1) experimental; urgency=low

  * New upstream version 2.0.13-stable
  * Pass "-Zbzip2 -z9" to dpkg-deb

 -- Anibal Monsalve Salazar <anibal@debian.org>  Sun, 28 Aug 2011 14:46:57 +1000

libevent (1.4.14b-stable-1) unstable; urgency=low

  * New upstream version 1.4.14b-stable
  * Source format is 3.0 (quilt)
  * Standards-Version is 3.9.2
  * Pass parameters -Zbzip2 and -z9 to dpkg-deb via dh_builddeb
  * Fix debhelper-but-no-misc-depends
  * Fix debian-rules-missing-recommended-target
  * Fix description-synopsis-starts-with-article

 -- Anibal Monsalve Salazar <anibal@debian.org>  Sun, 28 Aug 2011 12:49:20 +1000

=== debian/control ===
Source: libevent
Section: libs
Priority: optional
Maintainer: Anibal Monsalve Salazar <anibal@debian.org>
Uploaders: Leo Costela <costela@debian.org>
Build-Depends: debhelper (>= 8), autotools-dev, libssl-dev
Standards-Version: 3.9.2
Homepage: http://www.monkey.org/~provos/libevent/
Vcs-Browser: http://anonscm.debian.org/git/collab-maint/libevent.git
Vcs-Git: git://git.debian.org/git/collab-maint/libevent.git

Package: libevent-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libevent-2.0-5 (= ${binary:Version}),
 libevent-core-2.0-5 (= ${binary:Version}),
 libevent-extra-2.0-5 (= ${binary:Version}),
 libevent-pthreads-2.0-5 (= ${binary:Version}),
 libevent-openssl-2.0-5 (= ${binary:Version})
Description: Asynchronous event notification library (development files)
 Libevent is an asynchronous event notification library that provides a 
 mechanism to execute a callback function when a specific event occurs
 on a file descriptor or after a timeout has been reached.
 .
 This package includes development files for compiling against libevent.

Package: libevent-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, libevent-2.0-5 (= ${binary:Version}),
 libevent-core-2.0-5 (= ${binary:Version}),
 libevent-extra-2.0-5 (= ${binary:Version}),
 libevent-pthreads-2.0-5 (= ${binary:Version}),
 libevent-openssl-2.0-5 (= ${binary:Version})
Description: Asynchronous event notification library (debug symbols)
 Libevent is an asynchronous event notification library that provides a 
 mechanism to execute a callback function when a specific event occurs
 on a file descriptor or after a timeout has been reached.
 .
 This package includes debugging information for libevent.

Package: libevent-2.0-5
Priority: standard
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Asynchronous event notification library
 Libevent is an asynchronous event notification library that provides a
 mechanism to execute a callback function when a specific event occurs
 on a file descriptor or after a timeout has been reached.
 .
 It is meant to replace the asynchronous event loop found in
 event driven network servers. Currently, libevent supports /dev/poll,
 kqueue(2), event ports, select(2), poll(2) and epoll(4).
 .
 For backward compatibility and to transition to "libevent_core only"
 or "libevent_core + libevent_extra", the libevent source package builds
 the libevent library that includes everything in libevent_core and
 libevent_extra.

Package: libevent-core-2.0-5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Asynchronous event notification library (core)
 Libevent is an asynchronous event notification library that provides a
 mechanism to execute a callback function when a specific event occurs
 on a file descriptor or after a timeout has been reached.
 .
 It is meant to replace the asynchronous event loop found in
 event driven network servers. Currently, libevent supports /dev/poll,
 kqueue(2), event ports, select(2), poll(2) and epoll(4).
 .
 The libevent_core library includes event loops, timers, buffer code,
 and various small compatibility functions.
 .
 If you're writing software that only uses libevent's event loop, you
 should link against only the libevent_core library.

Package: libevent-extra-2.0-5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libevent-core-2.0-5 (= ${binary:Version})
Description: Asynchronous event notification library (extra)
 Libevent is an asynchronous event notification library that provides a
 mechanism to execute a callback function when a specific event occurs
 on a file descriptor or after a timeout has been reached.
 .
 It is meant to replace the asynchronous event loop found in
 event driven network servers. Currently, libevent supports /dev/poll,
 kqueue(2), event ports, select(2), poll(2) and epoll(4).
 .
 The libevent_extra library includes code for HTTP, DNS, RPC, and so
 on.
 .
 If you're writing software that uses libevent's protocol support, you
 need to link libevent_core and libevent_extra as well.

Package: libevent-pthreads-2.0-5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libevent-core-2.0-5 (= ${binary:Version})
Description: Asynchronous event notification library (pthreads)
 Libevent is an asynchronous event notification library that provides a
 mechanism to execute a callback function when a specific event occurs
 on a file descriptor or after a timeout has been reached.
 .
 It is meant to replace the asynchronous event loop found in
 event driven network servers. Currently, libevent supports /dev/poll,
 kqueue(2), event ports, select(2), poll(2) and epoll(4).
 .
 If you want threading support and you're using pthreads, you'll need
 to link against the libevent_pthreads library in addition to
 libevent_core.

Package: libevent-openssl-2.0-5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libevent-core-2.0-5 (= ${binary:Version})
Description: Asynchronous event notification library (openssl)
 Libevent is an asynchronous event notification library that provides a
 mechanism to execute a callback function when a specific event occurs
 on a file descriptor or after a timeout has been reached.
 .
 It is meant to replace the asynchronous event loop found in
 event driven network servers. Currently, libevent supports /dev/poll,
 kqueue(2), event ports, select(2), poll(2) and epoll(4).
 .
 There is now a bufferevent type that supports SSL/TLS using the
 OpenSSL library.  The code for this is build in a separate
 library, libevent_openssl, so that your programs don't need to
 link against OpenSSL unless they actually want SSL support.

=== debian/watch ===
version=3
http://monkey.org/~provos/libevent/ ../libevent-(.*?).tar.gz debian uupdate

## libevent 2.0.17-stable

=== debian/changelog ===
libevent (2.0.17-stable-1) unstable; urgency=low

  * [98fed68d] Imported Upstream version 2.0.17-stable
  * [82af6f34] update homepage to libevent.org
  * [becd7e37] re-adding multiarch to TODO
  * [8b2c71ac] shlibs: correct minimal version for current API (2.0.10)

 -- Leo Costela <costela@debian.org>  Mon, 13 Feb 2012 23:32:24 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Leo Costela <costela@debian.org>
 Build-Depends: debhelper (>= 8), autotools-dev, libssl-dev
 Standards-Version: 3.9.2
-Homepage: http://www.monkey.org/~provos/libevent/
+Homepage: http://libevent.org/
 Vcs-Browser: http://anonscm.debian.org/git/collab-maint/libevent.git
 Vcs-Git: git://git.debian.org/git/collab-maint/libevent.git

=== debian/rules ===
--- 
+++ 
@@ -11,3 +11,6 @@
 
 override_dh_strip:
 	dh_strip --dbg-package=libevent-dbg
+
+override_dh_builddeb:
+	dh_builddeb -- -Zbzip2 -z9

=== debian/watch ===
version=3
http://libevent.org .*/libevent-(.*?).tar.gz debian uupdate

## libevent 2.0.19-stable

=== debian/changelog ===
libevent (2.0.19-stable-3+deb7u1) wheezy-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Add CVE-2014-6272.patch patch.
    CVE-2014-6272: A flaw in the Libevent evbuffer API leaves programs using
    this API open to possible heap overflows.

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 23 Dec 2014 10:30:49 +0100

libevent (2.0.19-stable-3) unstable; urgency=low

  * [ceb52d98] DH compatibility level is 9
  * [7792ab18] Support multiarch (Closes: #675320)

 -- Anibal Monsalve Salazar <anibal@debian.org>  Sun, 03 Jun 2012 08:10:07 +1000

libevent (2.0.19-stable-2) unstable; urgency=low

  * [cbdbe5b8] add hardening build-flags (Closes: 673707)
  * [b5f4e321] change default compression to xz

 -- Leo Costela <costela@debian.org>  Mon, 21 May 2012 00:16:59 +0200

libevent (2.0.19-stable-1) unstable; urgency=low

  * [21c5f34e] Imported Upstream version 2.0.19-stable
  * [aad0456e] debian/watch: only check stable versions
  * [09bb9c1d] debian/control: bump policy to 3.9.3 (no changes)

 -- Leo Costela <costela@debian.org>  Mon, 07 May 2012 15:54:12 +0200

libevent (2.0.18-stable-1) unstable; urgency=low

  * [d094fba3] Imported Upstream version 2.0.18-stable
  * [6717e7ac] correct vcs-browse link

 -- Leo Costela <costela@debian.org>  Fri, 30 Mar 2012 16:24:30 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: optional
 Maintainer: Anibal Monsalve Salazar <anibal@debian.org>
 Uploaders: Leo Costela <costela@debian.org>
-Build-Depends: debhelper (>= 8), autotools-dev, libssl-dev
-Standards-Version: 3.9.2
+Build-Depends: dpkg-dev (>= 1.16.1~), debhelper (>= 9), autotools-dev, libssl-dev
+Standards-Version: 3.9.3
 Homepage: http://libevent.org/
-Vcs-Browser: http://anonscm.debian.org/git/collab-maint/libevent.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/libevent.git
 Vcs-Git: git://git.debian.org/git/collab-maint/libevent.git
 
 Package: libevent-dev
@@ -28,6 +28,7 @@
 Section: debug
 Priority: extra
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, libevent-2.0-5 (= ${binary:Version}),
  libevent-core-2.0-5 (= ${binary:Version}),
  libevent-extra-2.0-5 (= ${binary:Version}),
@@ -43,6 +44,8 @@
 Package: libevent-2.0-5
 Priority: standard
 Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Asynchronous event notification library
  Libevent is an asynchronous event notification library that provides a
@@ -60,6 +63,8 @@
 
 Package: libevent-core-2.0-5
 Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Asynchronous event notification library (core)
  Libevent is an asynchronous event notification library that provides a
@@ -78,6 +83,8 @@
 
 Package: libevent-extra-2.0-5
 Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends},
  libevent-core-2.0-5 (= ${binary:Version})
 Description: Asynchronous event notification library (extra)
@@ -97,6 +104,8 @@
 
 Package: libevent-pthreads-2.0-5
 Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends},
  libevent-core-2.0-5 (= ${binary:Version})
 Description: Asynchronous event notification library (pthreads)
@@ -114,6 +123,8 @@
 
 Package: libevent-openssl-2.0-5
 Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends},
  libevent-core-2.0-5 (= ${binary:Version})
 Description: Asynchronous event notification library (openssl)

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed,--no-undefined,--no-add-needed

%:
	dh $@ --with autotools-dev

override_dh_auto_configure:
	dh_auto_configure -- \
		--disable-libevent-regress \
		$(shell dpkg-buildflags --export=configure)

override_dh_strip:
	dh_strip --dbg-package=libevent-dbg

override_dh_builddeb:
	dh_builddeb -- -Zbzip2 -z9

## libevent 2.0.21-stable

=== debian/changelog ===
libevent (2.0.21-stable-2ubuntu0.16.04.1) xenial-security; urgency=medium

  * SECURITY UPDATE: buffer overread in name_parse()
    - debian/patches/CVE-2016-10195.patch: fix length check in evdns.c.
    - CVE-2016-10195
  * SECURITY UPDATE: integer overflow in evutil_parse_sockaddr_port()
    - debian/patches/CVE-2016-10196.patch: use size_t for length in
      evutil.c.
    - CVE-2016-10196
  * SECURITY UPDATE: OOB read via empty hostname
    - debian/patches/CVE-2016-10197-1.patch: check result in evdns.c.
    - debian/patches/CVE-2016-10197-2.patch: add test to
      test/regress_dns.c.
    - CVE-2016-10197

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 10 Mar 2017 14:12:18 -0500

libevent (2.0.21-stable-2) unstable; urgency=high

  * Fix CVE-2014-6272: potential heap overflow in buffer/bufferevent APIs.
    Add upstream patch: 20d6d445.patch.
    Closes: #774645.
  * Don't use deprecated compression for data tarball.
    Use default compression for data tarball.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Wed, 07 Jan 2015 11:33:15 +0000

libevent (2.0.21-stable-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Update config.* to fix FTBFS on ppc64el. Closes: #750693

 -- Andreas Barth <aba@ayous.org>  Mon, 25 Aug 2014 16:03:50 +0000

libevent (2.0.21-stable-1) unstable; urgency=low

  * [dd23c3ce] Imported Upstream version 2.0.21-stable
    - fix memleaks in evdns (closes: 679217)
  * [bbc5530e] debian/control: use canonical VCS URL

 -- Leo Costela <costela@debian.org>  Sun, 19 May 2013 00:40:30 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: libevent
 Section: libs
 Priority: optional
-Maintainer: Anibal Monsalve Salazar <anibal@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Anibal Monsalve Salazar <anibal@debian.org>
 Uploaders: Leo Costela <costela@debian.org>
-Build-Depends: dpkg-dev (>= 1.16.1~), debhelper (>= 9), autotools-dev, libssl-dev
+Build-Depends: dpkg-dev (>= 1.16.1~), debhelper (>= 9), libssl-dev, dh-autoreconf
 Standards-Version: 3.9.3
 Homepage: http://libevent.org/
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/libevent.git
-Vcs-Git: git://git.debian.org/git/collab-maint/libevent.git
+Vcs-Git: git://anonscm.debian.org/collab-maint/libevent.git
 
 Package: libevent-dev
 Section: libdevel

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed,--no-undefined,--no-add-needed
 
 %:
-	dh $@ --with autotools-dev
+	dh $@ --with autoreconf
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
@@ -14,6 +14,3 @@
 
 override_dh_strip:
 	dh_strip --dbg-package=libevent-dbg
-
-override_dh_builddeb:
-	dh_builddeb -- -Zbzip2 -z9

## libevent 2.0.21-stable-2maemo1

=== debian/changelog ===
libevent (2.0.21-stable-2maemo1) unstable; urgency=high

  * Fix CVE-2014-6272: potential heap overflow in buffer/bufferevent APIs.
  * Add upstream patch: 20d6d445.patch.

 -- Christian Weniger <less_to_space@web.de>  Wed, 07 Jan 2015 11:33:15 +0000

## libevent 2.1.8-stable

=== debian/changelog ===
libevent (2.1.8-stable-4) unstable; urgency=medium

  * Don't link all libraries with -lcrypto (Closes: #869900)

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 31 Jul 2017 18:13:49 +0200

libevent (2.1.8-stable-3) unstable; urgency=medium

  * Upload to unstable

 -- Balint Reczey <rbalint@ubuntu.com>  Sun, 30 Jul 2017 08:08:13 +0200

libevent (2.1.8-stable-2) experimental; urgency=medium

  * Use my @ubuntu.com email address in Uploaders field
  * Fix symbols files for hurd-* and kfreebsd-* architectures

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 24 Jul 2017 17:49:43 +0200

libevent (2.1.8-stable-1) experimental; urgency=low

  * New upstream stable release (Closes: #853799, #833212)
  * Drop patches integrated upstream
  * Bump .so versions and related versions in package names
  * Don't pass --no-undefined and --no-add-needed to ld
  * Bump compat level to 10
  * Tidy up d/control using cme fix dpkg-control
  * Drop libevent-dbg package in favor of automatically generated dbgsym
    packages
  * Bump standards version to 3.9.8.
    Migrating to using symbols files is recorded in TODO
  * Drop dh-autoreconf patch which does not apply anymore
  * Update shared library versions and start using symbols files
  * Ship whatsnew-2.1.txt

 -- Balint Reczey <balint@balintreczey.hu>  Mon, 13 Feb 2017 12:48:24 +0100

libevent (2.0.21-stable-3) unstable; urgency=medium

  * Fix three vulnerabilites (Closes: #854092):
    - DNS remote stack overread vulnerability (CVE-2016-10195)
    - (Stack) buffer overflow in evutil_parse_sockaddr_port()
      (CVE-2016-10196)
    - Out-of-bounds read in search_make_new() (CVE-2016-10197)
  * Add myself as an uploader
  * ACK NMU

 -- Balint Reczey <balint@balintreczey.hu>  Sun, 12 Feb 2017 21:43:18 +0100

libevent (2.0.21-stable-2.1) unstable; urgency=medium

  [ Helmut Grohne ]
  * Non-maintainer upload.

  [ Kurt Roeckx ]
  * Add openssl_1.1.patch. Closes: #828393

 -- Helmut Grohne <helmut@subdivi.de>  Thu, 03 Nov 2016 08:43:46 +0100

=== debian/control ===
Source: libevent
Maintainer: Anibal Monsalve Salazar <anibal@debian.org>
Uploaders: Balint Reczey <rbalint@ubuntu.com>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 10~),
               autotools-dev,
               libssl-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libevent.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/libevent.git
Homepage: http://libevent.org/

Package: libevent-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libevent-2.1-6 (= ${binary:Version}),
         libevent-core-2.1-6 (= ${binary:Version}),
         libevent-extra-2.1-6 (= ${binary:Version}),
         libevent-pthreads-2.1-6 (= ${binary:Version}),
         libevent-openssl-2.1-6 (= ${binary:Version})
Description: Asynchronous event notification library (development files)
 Libevent is an asynchronous event notification library that provides a 
 mechanism to execute a callback function when a specific event occurs
 on a file descriptor or after a timeout has been reached.
 .
 This package includes development files for compiling against libevent.

Package: libevent-2.1-6
Architecture: any
Multi-Arch: same
Priority: standard
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Asynchronous event notification library
 Libevent is an asynchronous event notification library that provides a
 mechanism to execute a callback function when a specific event occurs
 on a file descriptor or after a timeout has been reached.
 .
 It is meant to replace the asynchronous event loop found in
 event driven network servers. Currently, libevent supports /dev/poll,
 kqueue(2), event ports, select(2), poll(2) and epoll(4).
 .
 For backward compatibility and to transition to "libevent_core only"
 or "libevent_core + libevent_extra", the libevent source package builds
 the libevent library that includes everything in libevent_core and
 libevent_extra.

Package: libevent-core-2.1-6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Asynchronous event notification library (core)
 Libevent is an asynchronous event notification library that provides a
 mechanism to execute a callback function when a specific event occurs
 on a file descriptor or after a timeout has been reached.
 .
 It is meant to replace the asynchronous event loop found in
 event driven network servers. Currently, libevent supports /dev/poll,
 kqueue(2), event ports, select(2), poll(2) and epoll(4).
 .
 The libevent_core library includes event loops, timers, buffer code,
 and various small compatibility functions.
 .
 If you're writing software that only uses libevent's event loop, you
 should link against only the libevent_core library.

Package: libevent-extra-2.1-6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libevent-core-2.1-6 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: Asynchronous event notification library (extra)
 Libevent is an asynchronous event notification library that provides a
 mechanism to execute a callback function when a specific event occurs
 on a file descriptor or after a timeout has been reached.
 .
 It is meant to replace the asynchronous event loop found in
 event driven network servers. Currently, libevent supports /dev/poll,
 kqueue(2), event ports, select(2), poll(2) and epoll(4).
 .
 The libevent_extra library includes code for HTTP, DNS, RPC, and so
 on.
 .
 If you're writing software that uses libevent's protocol support, you
 need to link libevent_core and libevent_extra as well.

Package: libevent-pthreads-2.1-6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libevent-core-2.1-6 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: Asynchronous event notification library (pthreads)
 Libevent is an asynchronous event notification library that provides a
 mechanism to execute a callback function when a specific event occurs
 on a file descriptor or after a timeout has been reached.
 .
 It is meant to replace the asynchronous event loop found in
 event driven network servers. Currently, libevent supports /dev/poll,
 kqueue(2), event ports, select(2), poll(2) and epoll(4).
 .
 If you want threading support and you're using pthreads, you'll need
 to link against the libevent_pthreads library in addition to
 libevent_core.

Package: libevent-openssl-2.1-6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libevent-core-2.1-6 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: Asynchronous event notification library (openssl)
 Libevent is an asynchronous event notification library that provides a
 mechanism to execute a callback function when a specific event occurs
 on a file descriptor or after a timeout has been reached.
 .
 It is meant to replace the asynchronous event loop found in
 event driven network servers. Currently, libevent supports /dev/poll,
 kqueue(2), event ports, select(2), poll(2) and epoll(4).
 .
 There is now a bufferevent type that supports SSL/TLS using the
 OpenSSL library.  The code for this is build in a separate
 library, libevent_openssl, so that your programs don't need to
 link against OpenSSL unless they actually want SSL support.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
#,--no-undefined,--no-add-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		--disable-libevent-regress \
		$(shell dpkg-buildflags --export=configure)

override_dh_strip:
	dh_strip --dbgsym-migration="libevent-dbg (<< 2.1.8-stable-1~)" || dh_strip

override_dh_auto_test:
	echo 'skipping tests'

## libevent 2.1.11

=== CMakeLists.txt ===
#
# Libevent CMake project
#
# Based on initial work by:
#    Alexey Ozeritsky
#
# Additional changes:
#   Brodie Thiesfield
#   Joakim Soderberg
#   Trond Norbye
#   Sergei Nikulov
#
#   Build example:
#
#       cd libevent
#       md build
#       cd build
#       cmake -G "Visual Studio 10" ..
#       start libevent.sln
#

cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

if (POLICY CMP0054)
    cmake_policy(SET CMP0054 NEW)
endif()
if (POLICY CMP0074)
    cmake_policy(SET CMP0074 NEW)
endif()
if (POLICY CMP0075)
    cmake_policy(SET CMP0075 NEW)
endif()

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release
        CACHE STRING "Set build type to Debug o Release (default Release)" FORCE)
endif()
string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)

# get rid of the extra default configurations
# what? why would you get id of other useful build types? - Ellzey
set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "Limited configurations" FORCE)

set(EVENT__LIBRARY_TYPE DEFAULT CACHE STRING
    "Set library type to SHARED/STATIC/BOTH (default SHARED for MSVC, otherwise BOTH)")

project(libevent C)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")
string(REGEX MATCH "SunOS" SOLARIS "${CMAKE_SYSTEM_NAME}")


include(CheckTypeSize)
include(CheckFunctionExistsEx)
include(CheckFileOffsetBits)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckVariableExists)
include(CheckSymbolExists)
include(CheckStructHasMember)
include(CheckCSourceCompiles)
include(CheckPrototypeDefinition)
include(CheckFunctionKeywords)
include(CheckConstExists)
include(AddCompilerFlags)
include(VersionViaGit)

event_fuzzy_version_from_git()

set(EVENT_VERSION_MAJOR ${EVENT_GIT___VERSION_MAJOR})
set(EVENT_VERSION_MINOR ${EVENT_GIT___VERSION_MINOR})
set(EVENT_VERSION_PATCH ${EVENT_GIT___VERSION_PATCH})
set(EVENT_VERSION_STAGE ${EVENT_GIT___VERSION_STAGE})


set(EVENT_ABI_MAJOR ${EVENT_VERSION_MAJOR})
set(EVENT_ABI_MINOR ${EVENT_VERSION_MINOR})
set(EVENT_ABI_PATCH ${EVENT_VERSION_PATCH})

set(EVENT_ABI_LIBVERSION
    "${EVENT_ABI_MAJOR}.${EVENT_ABI_MINOR}.${EVENT_ABI_PATCH}")

set(EVENT_PACKAGE_VERSION
    "${EVENT_VERSION_MAJOR}.${EVENT_VERSION_MINOR}.${EVENT_VERSION_PATCH}")

set(EVENT_NUMERIC_VERSION 0x02010b00)
# equals to VERSION_INFO in Makefile.am
set(EVENT_ABI_LIBVERSION_CURRENT   7)
set(EVENT_ABI_LIBVERSION_REVISION  0)
set(EVENT_ABI_LIBVERSION_AGE       0)

# equals to RELEASE in Makefile.am
set(EVENT_PACKAGE_RELEASE 2.1)

# only a subset of names can be used, defaults to "beta"
set(EVENT_STAGE_NAME ${EVENT_VERSION_STAGE})

# a list that defines what can set for EVENT_STAGE_VERSION
set(EVENT__ALLOWED_STAGE_NAMES
	rc
	beta
	alpha
	alpha-dev
	release
	stable
)
list(
	FIND EVENT__ALLOWED_STAGE_NAMES
	"${EVENT_STAGE_NAME}"
	EVENT__STAGE_RET
)
if (EVENT__STAGE_RET EQUAL -1)
	message(WARNING
		"stage ${EVENT_STAGE_NAME} is not allowed, reset to beta")
	set(EVENT_STAGE_NAME beta)
endif()

set(EVENT_VERSION
	"${EVENT_VERSION_MAJOR}.${EVENT_VERSION_MINOR}.${EVENT_VERSION_PATCH}-${EVENT_STAGE_NAME}")

option(EVENT__DISABLE_DEBUG_MODE
    "Define if libevent should build without support for a debug mode" OFF)

option(EVENT__ENABLE_VERBOSE_DEBUG
    "Enables verbose debugging" OFF)

option(EVENT__DISABLE_MM_REPLACEMENT
    "Define if libevent should not allow replacing the mm functions" OFF)

option(EVENT__DISABLE_THREAD_SUPPORT
    "Define if libevent should not be compiled with thread support" OFF)

option(EVENT__DISABLE_OPENSSL
    "Define if libevent should build without support for OpenSSL encryption" OFF)

option(EVENT__DISABLE_BENCHMARK
    "Defines if libevent should build without the benchmark executables" OFF)

option(EVENT__DISABLE_TESTS
    "If tests should be compiled or not" OFF)

option(EVENT__DISABLE_REGRESS
    "Disable the regress tests" OFF)

option(EVENT__DISABLE_SAMPLES
    "Disable sample files" OFF)

option(EVENT__DISABLE_CLOCK_GETTIME
    "Do not use clock_gettime even if it is available" OFF)

option(EVENT__FORCE_KQUEUE_CHECK
    "When crosscompiling forces running a test program that verifies that Kqueue works with pipes. Note that this requires you to manually run the test program on the cross compilation target to verify that it works. See cmake documentation for try_run for more details" OFF)

# TODO: Add --disable-largefile     omit support for large files
option(EVENT__COVERAGE
"Enable running gcov to get a test coverage report (only works with GCC/CLang). Make sure to enable -DCMAKE_BUILD_TYPE=Debug as well." OFF)

# Put the libaries and binaries that get built into directories at the
# top of the build tree rather than in hard-to-find leaf directories.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)

if (EVENT__ENABLE_VERBOSE_DEBUG)
    add_definitions(-DUSE_DEBUG=1)
endif()

# make it colorful under ninja-build
if ("${CMAKE_GENERATOR}" STREQUAL "Ninja")
    add_compiler_flags(-fdiagnostics-color=always)
endif()

# Setup compiler flags for coverage.
if (EVENT__COVERAGE)
    if (NOT "${CMAKE_BUILD_TYPE_LOWER}" STREQUAL "debug")
        message(FATAL_ERROR "Coverage requires -DCMAKE_BUILD_TYPE=Debug")
    endif()

    message(STATUS "Setting coverage compiler flags")

    set(CMAKE_REQUIRED_LIBRARIES "--coverage")
    add_compiler_flags(-g -O0 --coverage)
    set(CMAKE_REQUIRED_LIBRARIES "")
endif()

set(GNUC 0)
set(CLANG 0)
set(MSVC 0)
if (("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang") OR
    ("${CMAKE_C_COMPILER_ID}" STREQUAL "AppleClang"))
    set(CLANG 1)
endif()
if (("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU") OR (${CLANG}))
    set(GNUC 1)
endif()
if (("${CMAKE_C_COMPILER_ID}" STREQUAL "MSVC") OR (${CLANG}))
    set(MSVC 1)
endif()

# Detect library type
set(EVENT_LIBRARY_TYPE)
if ("${EVENT__LIBRARY_TYPE}" STREQUAL "DEFAULT")
    if (${MSVC})
        set(EVENT_LIBRARY_TYPE SHARED)
    else()
        set(EVENT_LIBRARY_TYPE BOTH)
    endif()
else()
    string(TOUPPER "${EVENT__LIBRARY_TYPE}" EVENT_LIBRARY_TYPE)
endif()
if ((${MSVC}) AND ("${EVENT_LIBRARY_TYPE}" STREQUAL "BOTH"))
    message(WARNING
      "Building SHARED and STATIC is not supported for MSVC "
      "(due to conflicts in library name"
      " between STATIC library and IMPORTED library for SHARED libraries)")
endif()
set(EVENT_LIBRARY_STATIC OFF)
set(EVENT_LIBRARY_SHARED OFF)
if ("${EVENT_LIBRARY_TYPE}" STREQUAL "BOTH")
    set(EVENT_LIBRARY_STATIC ON)
    set(EVENT_LIBRARY_SHARED ON)
elseif ("${EVENT_LIBRARY_TYPE}" STREQUAL "STATIC")
    set(EVENT_LIBRARY_STATIC ON)
elseif ("${EVENT_LIBRARY_TYPE}" STREQUAL "SHARED")
    set(EVENT_LIBRARY_SHARED ON)
else()
    message(FATAL_ERROR "${EVENT_LIBRARY_TYPE} is not supported")
endif()

if (${MSVC})
    set(msvc_static_runtime OFF)
    if ("${EVENT_LIBRARY_TYPE}" STREQUAL "STATIC")
        set(msvc_static_runtime ON)
    endif()

    # For more info:
    # - https://docs.microsoft.com/en-us/cpp/build/reference/md-mt-ld-use-run-time-library?view=vs-2017
    # - https://gitlab.kitware.com/cmake/community/wikis/FAQ#how-can-i-build-my-msvc-application-with-a-static-runtime
    option(EVENT__MSVC_STATIC_RUNTIME
           "Link static runtime libraries"
           ${msvc_static_runtime})

    if (EVENT__MSVC_STATIC_RUNTIME)
        foreach (flag_var
                 CMAKE_C_FLAGS
                 CMAKE_C_FLAGS_DEBUG
                 CMAKE_C_FLAGS_RELEASE
                 CMAKE_C_FLAGS_MINSIZEREL
                 CMAKE_C_FLAGS_RELWITHDEBINFO
        )
            if (${flag_var} MATCHES "/MD")
                string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
            endif()
        endforeach()
    endif()
endif()

# GNUC specific options.
if (${GNUC})
    option(EVENT__DISABLE_GCC_WARNINGS "Disable verbose warnings with GCC" OFF)
    option(EVENT__ENABLE_GCC_HARDENING "Enable compiler security checks" OFF)
    option(EVENT__ENABLE_GCC_FUNCTION_SECTIONS "Enable gcc function sections" OFF)
    option(EVENT__ENABLE_GCC_WARNINGS "Make all GCC warnings into errors" OFF)

    set(GCC_V ${CMAKE_C_COMPILER_VERSION})

    list(APPEND __FLAGS
         -Wall -Wextra -Wno-unused-parameter -Wstrict-aliasing -Wstrict-prototypes

         -fno-strict-aliasing # gcc 2.9.5+
         -Wmissing-prototypes

         # gcc 4
         -Winit-self
         -Wmissing-field-initializers
         -Wdeclaration-after-statement

         # gcc 4.2
         -Waddress
         -Wnormalized=id
         -Woverride-init

         # gcc 4.5
         -Wlogical-op

         -Wwrite-strings
    )

    if (${CLANG})
        list(APPEND __FLAGS -Wno-unused-function)
    endif()

    if (EVENT__DISABLE_GCC_WARNINGS)
        list(APPEND __FLAGS -w)
    endif()

    if (EVENT__ENABLE_GCC_HARDENING)
        list(APPEND __FLAGS
             -fstack-protector-all
             -fwrapv
             -fPIE
             -Wstack-protector
             "--param ssp-buffer-size=1")

        add_definitions(-D_FORTIFY_SOURCE=2)
    endif()

    if (EVENT__ENABLE_GCC_FUNCTION_SECTIONS)
        list(APPEND __FLAGS -ffunction-sections)
        # TODO: Add --gc-sections support. We need some checks for NetBSD to ensure this works.
    endif()

    if (EVENT__ENABLE_GCC_WARNINGS)
        list(APPEND __FLAGS -Werror)
    endif()

    add_compiler_flags(${__FLAGS})
endif()

if (APPLE)
    # Get rid of deprecated warnings for OpenSSL on OSX 10.7 and greater.
    add_compiler_flags(
        -Wno-error=deprecated-declarations
        -Qunused-arguments
    )
endif()

# Winsock.
if(WIN32)
    set(CMAKE_EXTRA_INCLUDE_FILES winsock2.h ws2tcpip.h)
    set(CMAKE_REQUIRED_LIBRARIES  ws2_32.lib shell32.lib advapi32.lib)
    set(CMAKE_REQUIRED_DEFINITIONS -FIwinsock2.h -FIws2tcpip.h)
endif()
if (SOLARIS)
    set(CMAKE_REQUIRED_LIBRARIES socket nsl)
endif()

# Check if _GNU_SOURCE is available.
if (NOT DEFINED _GNU_SOURCE)
  CHECK_SYMBOL_EXISTS(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

  if (NOT _GNU_SOURCE)
    unset(_GNU_SOURCE CACHE)
    CHECK_SYMBOL_EXISTS(_GNU_SOURCE "features.h" _GNU_SOURCE)
  endif()

  if (ANDROID)
    set(_GNU_SOURCE TRUE)
  endif()
endif()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE=1)
endif()

CHECK_INCLUDE_FILE(sys/types.h EVENT__HAVE_SYS_TYPES_H)
if(EVENT__HAVE_SYS_TYPES_H)
    list(APPEND CMAKE_EXTRA_INCLUDE_FILES sys/types.h)
endif()

CHECK_INCLUDE_FILE(sys/socket.h EVENT__HAVE_SYS_SOCKET_H)
if(EVENT__HAVE_SYS_SOCKET_H)
    list(APPEND CMAKE_EXTRA_INCLUDE_FILES sys/socket.h)
endif()

CHECK_INCLUDE_FILE(netinet/in.h EVENT__HAVE_NETINET_IN_H)
if(EVENT__HAVE_NETINET_IN_H)
    list(APPEND CMAKE_EXTRA_INCLUDE_FILES netinet/in.h)
endif()

CHECK_INCLUDE_FILE(sys/un.h EVENT__HAVE_SYS_UN_H)
if(EVENT__HAVE_SYS_UN_H)
    list(APPEND CMAKE_EXTRA_INCLUDE_FILES sys/un.h)
endif()

if(WIN32)
    CHECK_INCLUDE_FILE(afunix.h EVENT__HAVE_AFUNIX_H)
    if(EVENT__HAVE_AFUNIX_H)
        list(APPEND CMAKE_EXTRA_INCLUDE_FILES afunix.h)
    endif()
endif()
CHECK_TYPE_SIZE("struct sockaddr_un" EVENT__HAVE_STRUCT_SOCKADDR_UN)

CHECK_INCLUDE_FILE(netinet/in6.h EVENT__HAVE_NETINET_IN6_H)
if(EVENT__HAVE_NETINET_IN6_H)
    list(APPEND CMAKE_EXTRA_INCLUDE_FILES netinet/in6.h)
endif()

CHECK_INCLUDE_FILE(unistd.h EVENT__HAVE_UNISTD_H)
CHECK_INCLUDE_FILE(netdb.h EVENT__HAVE_NETDB_H)
CHECK_INCLUDE_FILE(dlfcn.h EVENT__HAVE_DLFCN_H)
CHECK_INCLUDE_FILE(arpa/inet.h EVENT__HAVE_ARPA_INET_H)
CHECK_INCLUDE_FILE(fcntl.h EVENT__HAVE_FCNTL_H)
if(EVENT__HAVE_FCNTL_H)
    list(APPEND CMAKE_EXTRA_INCLUDE_FILES fcntl.h)
endif()
CHECK_INCLUDE_FILE(inttypes.h EVENT__HAVE_INTTYPES_H)
CHECK_INCLUDE_FILE(memory.h EVENT__HAVE_MEMORY_H)
CHECK_INCLUDE_FILE(poll.h EVENT__HAVE_POLL_H)
CHECK_INCLUDE_FILE(port.h EVENT__HAVE_PORT_H)
if(EVENT__HAVE_PORT_H)
    list(APPEND CMAKE_EXTRA_INCLUDE_FILES port.h)
endif()
CHECK_INCLUDE_FILE(signal.h EVENT__HAVE_SIGNAL_H)
CHECK_INCLUDE_FILE(stdarg.h EVENT__HAVE_STDARG_H)
